//
//  RBitmapGraphicsDevice.m
//  R
//
//  Created by Byron Ellis on 1/22/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "RBitmapGraphicsDevice.h"


@implementation RBitmapGraphicsDevice
- (void)makeLayer {
	if(NULL != bytes)
		free(bytes);
	size_t width    = size.width;
	size_t height   = size.height;
	size_t rowBytes = (width*8*4 + 7)/8;
	bytes = malloc(rowBytes*height);
	memset(bytes,0,rowBytes*height);
	CGContextRef ctx = CGBitmapContextCreate(bytes,width,height,8,rowBytes,CGColorSpaceCreateWithName(kCGColorSpaceGenericRGB),kCGImageAlphaPremultipliedLast);
	CGContextTranslateCTM(ctx,0,size.height);
	CGContextScaleCTM(ctx,1.0,-1.0);
	CGContextSetShouldAntialias(ctx,false);
	[self setContext:ctx];
	
}	

+ (RBitmapGraphicsDevice*)deviceWithSize:(NSSize)aSize deviceDesc:(void*)devDesc delegate:(id)delegate {
	return [[self alloc] initWithSize:aSize deviceDesc:devDesc delegate:delegate];
}

- (id)initWithSize:(NSSize)aSize deviceDesc:(void*)dd delegate:(id)del {
	if(nil == [super initWithContext:NULL deviceDesc:dd delegate:del]) return nil;
	size = NSMakeSize(aSize.width,aSize.height);
	bytes= NULL;
	[self makeLayer];
	return self;
}



- (NSSize)deviceSize {
	NSSize newSize = [super deviceSize];
	if(newSize.width != size.width || newSize.height != size.height) {
		size = newSize;
		[self makeLayer];
	}
	return newSize;
}

- (CGRect)bounds {
	return (CGRect){0,0,size.width,size.height};
}

- (void)drawInRect:(NSRect)rect {
	CGImageRef image = CGBitmapContextCreateImage(context);
	CGContextDrawImage([[NSGraphicsContext currentContext] graphicsPort],CGRectMake(rect.origin.x,rect.origin.y,rect.size.width,rect.size.height),image);
	CGImageRelease(image);	
}

@end
