#import "RDocumentController.h"


@implementation RDocumentController
- (id)init {
	if(nil == [super init]) return nil;
	docTypes = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleDocumentTypes"];
	return self;
}
- (NSString*)documentTypeForIndex:(NSUInteger)index {
	if(index > [docTypes count]) return @"";
	return [[docTypes objectAtIndex:index] objectForKey:@"CFBundleTypeName"];
}

//- (Class)documentClassForType:(NSString*)docType {
//	Class ret = [super documentClassForType:docType];
//	if(nil == ret) {
//		id desc = [self _typeDescriptionForName:docType];
//		if(NO == (BOOL)[desc isEditableByThisApp] && NO == (BOOL)[desc isViewableByThisApp]) return NSClassFromString((NSString*)[desc className]);
//		NSLog([[desc class] description]);
//	}
//	return ret;
//}

- (NSDocument*)makeConsoleDocumentOfType:(NSString*)consoleType error:(NSError**)error {
	*error = nil;
	for(NSDictionary *docType in docTypes) {
		NSString *consoleType = [docType objectForKey:@"RConsoleType"];
		if(nil != consoleType && [consoleType isEqual:consoleType]) {
			Class cls = NSClassFromString((NSString*)[docType objectForKey:@"NSDocumentClass"]);
			return [[cls alloc] init];
		}
	}
	return nil;
}

- (NSDocument*)makeDeviceDocumentOfType:(NSString*)consoleType error:(NSError**)error {
	*error = nil;
	for(NSDictionary *docType in docTypes) {
		NSString *consoleType = [docType objectForKey:@"RDeviceType"];
		if(nil != consoleType && [consoleType isEqual:consoleType]) {
			Class cls = NSClassFromString((NSString*)[docType objectForKey:@"NSDocumentClass"]);
			return [[cls alloc] init];
		}
	}
	return nil;
}

//We can set up menu items to identify WHICH type of document to open based on an integer tag. Which is awesome.
/*
- (void)newDocument:(id)sender {
	if([sender respondsToSelector:@selector(tag)]) 
		[self openUntitledDocumentOfType:[self documentTypeForIndex:[sender tag]] display:YES];
	else
		[super newDocument:sender];
}
*/

- (NSString*)principalConsoleDocumentType {
	//This should be editable at some point.
	return [[[NSBundle mainBundle] infoDictionary] objectForKey:@"RPrincipalConsoleDocumentType"];
}
- (NSString*)deviceDocumentTypeForDisplay:(NSString*)display {
	if(display == nil || [display isEqualTo:@""]) {
		return [[[NSBundle mainBundle] infoDictionary] objectForKey:@"RPrincipalDeviceDocumentType"];		
	} else {
		return display;
	}
}


@end
